package com.engine.salary.mapper.auth;

import com.engine.salary.entity.auth.po.AuthDataPO;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;

public interface AuthDataMapper {

    /**
     * 查询所有记录
     *
     * @return 返回集合，没有返回空List
     */
    List<AuthDataPO> listAll();

    /**
     * 条件查询
     *
     * @return 返回集合，没有返回空List
     */
    List<AuthDataPO> listSome(AuthDataPO authData);


    /**
     * 根据主键查询
     *
     * @param id 主键
     * @return 返回记录，没有返回null
     */
    AuthDataPO getById(Long id);

    /**
     * 新增，忽略null字段
     *
     * @param authData 新增的记录
     * @return 返回影响行数
     */
    int insertIgnoreNull(AuthDataPO authData);

    /**
     * 修改，修改所有字段
     *
     * @param authData 修改的记录
     * @return 返回影响行数
     */
    int update(AuthDataPO authData);

    /**
     * 修改，忽略null字段
     *
     * @param authData 修改的记录
     * @return 返回影响行数
     */
    int updateIgnoreNull(AuthDataPO authData);

    /**
     * 删除记录
     *
     * @param authData 待删除的记录
     * @return 返回影响行数
     */
    int delete(AuthDataPO authData);

    /**
     * 批量删除记录
     *
     * @param ids 主键id集合
     */
    void deleteByIds(@Param("ids") Collection<Long> ids);


    /**
     * 根据角色id删除
     * @param roleId roleId
     */
    void deleteByRoleId(Long roleId);
}